<div class="animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          <i class="fa fa-globe"></i>{{ "websites.title" | translate }}
          <span class="float-right"
            ><button
              [disabled]="add || editStatus"
              (click)="addWebsite()"
              class="btn btn-block btn-primary"
            >
              {{ "common.add" | translate }}
            </button></span
          >
        </div>
        <div class="card-body">
          <div class="row justify-content-between mb-2">
            <div class="col-6">
              <span class="float-left pr-3 show-entity-per-page-label">{{
                "common.show" | translate
              }}</span>
              <select
                (change)="onSearch()"
                [(ngModel)]="paging.limit"
                class="form-control float-left"
                style="max-width: 70px"
                [disabled]="add || editStatus"
              >
                <option *ngFor="let i of PAGING_PER_PAGE" value="{{ i.value }}">
                  {{ i.label }}
                </option>
              </select>
            </div>
            <div class="col-2">
              <div class="input-group float-right">
                <input
                  [(ngModel)]="keywordSearch"
                  type="text"
                  class="form-control"
                  placeholder="{{ 'common.search' | translate }}"
                />
                <div class="input-group-append">
                  <button
                    (click)="onSearch()"
                    class="btn btn-dark"
                    type="button"
                    [disabled]="add || editStatus"
                  >
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </div>
          </div>
          <table class="table table-bordered table-sort-icon">
            <thead>
              <tr
                appSort
                [(orderBy)]="order.orderBy"
                [(orderType)]="order.orderType"
                (orderChange)="changeOder($event)"
              >
                <th appSortBy="website_domain" class="text-center">
                  {{ "websites.domain" | translate }}<fa-icon></fa-icon>
                </th>
                <th class="text-center">
                  {{ "websites.service" | translate }}
                </th>
                <th appSortBy="cache" class="text-center">
                  {{ "websites.cache" | translate }}<fa-icon></fa-icon>
                </th>
                <th class="text-center">
                  {{ "websites.listened" | translate }}
                </th>
                <!-- <th class="text-center">{{ "websites.ssl" | translate }}</th> -->
                <th class="text-center">{{ "common.action" | translate }}</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let website of websites; let i = index">
                <td *ngIf="!editing[i]">{{ website.website_domain }}</td>
                <td *ngIf="!editing[i]">
                  <div class="row" *ngFor="let u of website.upstream">
                    <div class="col-6">
                      <span class="pr-3">{{ u.ip }} : {{ u.port }}</span>
                    </div>
                    <div class="col-6">
                      <span class="badge badge-warning"> {{ u.type }}</span>
                      <span *ngIf="u.protocol" class="badge badge-warning">
                        {{ u.protocol }}</span
                      >
                    </div>
                    <br />
                  </div>
                </td>
                <td class="text-center" *ngIf="!editing[i]">
                  <span *ngIf="website.cache" class="badge badge-success"
                    >On</span
                  >
                  <span *ngIf="!website.cache" class="badge badge-warning"
                    >Off</span
                  >
                </td>
                <td *ngIf="!editing[i]" class="text-center">
                  <span class="pr-5">{{ website.listened.main }} </span>
                  <span
                    *ngIf="website.listened.protocol"
                    class="badge badge-warning"
                  >
                    {{ website.listened.protocol }}</span
                  >
                </td>

                <td class="text-center" *ngIf="!editing[i]">
                  <div class="btn-group">
                    <button
                      type="button"
                      class="btn btn-success btn-sm"
                      [disabled]="add || editStatus"
                      (click)="changeEditStatus(i)"
                    >
                      <i class="icon-pencil"></i>
                      <span class="d-none d-md-inline">
                        {{ "common.edit" | translate }}</span
                      >
                    </button>
                    <button
                      type="button"
                      (click)="delete(deleteModal, i)"
                      class="btn btn-danger btn-sm"
                      [disabled]="add || editStatus"
                    >
                      <i class="icon-trash"></i>
                      <span class="d-none d-md-inline">
                        {{ "common.delete" | translate }}</span
                      >
                    </button>
                  </div>
                </td>
                <td *ngIf="editing[i]" [formGroup]="websiteForm">
                  <input
                    class="form-control"
                    [placeholder]="'website' | translate"
                    type="text"
                    formControlName="website_domain"
                    (change)="changeValue($event, 'domain')"
                  />
                  <span class="form-text text-danger" *ngIf="checkDomain">
                    {{ checkDomain | translate }}
                  </span>
                </td>

                <td *ngIf="editing[i]" [formGroup]="websiteForm">
                  <button
                    class="btn btn-block btn-outline-primary"
                    (click)="ipPortTooltip = !ipPortTooltip"
                  >
                    {{ "websites.detail" | translate }}
                  </button>
                  <span class="form-text text-danger" *ngIf="checkService">
                    {{ checkService | translate }}
                  </span>
                  <div
                    class="_tooltip tooltip__initiator text-left"
                    *ngIf="ipPortTooltip"
                  >
                    <div class="tooltip__item" style="width: 687px">
                      <div class="card m-0">
                        <div class="card-header">
                          <span style="color: white">
                            {{ "websites.service_config" | translate }}
                          </span>
                          <button
                            type="button"
                            class="close"
                            aria-label="Close"
                            (click)="ipPortTooltip = !ipPortTooltip"
                          >
                            <i class="fa fa-times" style="color: yellow"></i>
                          </button>
                        </div>
                        <div class="card-body">
                          <form [formGroup]="websiteForm">
                            <div formArrayName="upstream">
                              <table class="table table-borderless">
                                <thead>
                                  <tr>
                                    <th class="text-center">
                                      {{ "websites.ip" | translate }}
                                    </th>
                                    <th class="text-center">
                                      {{ "websites.port" | translate }}
                                    </th>
                                    <th class="text-center">
                                      {{ "websites.type" | translate }}
                                    </th>
                                    <th class="text-center">
                                      {{ "websites.protocol" | translate }}
                                    </th>
                                  </tr>
                                </thead>
                                <tbody>
                                  <tr
                                    *ngFor="
                                      let u of getUpstream.controls;
                                      let i = index
                                    "
                                    [formGroupName]="i"
                                  >
                                    <td style="width: 30%">
                                      <input
                                        class="form-control"
                                        type="text"
                                        formControlName="ip"
                                        required
                                        pattern="^(?!.*\.$)((?!0\d)(1?\d?\d|25[0-5]|2[0-4]\d)(\.|$)){4}$"
                                        (change)="
                                          changeValue(
                                            this.getUpstream.at(i).get('ip')
                                              .value,
                                            'ip',
                                            i
                                          )
                                        "
                                      />
                                      <span
                                        class="form-text text-danger"
                                        *ngIf="u.value.checkIpServie"
                                      >
                                        {{ u.value.checkIpServie | translate }}
                                      </span>
                                    </td>
                                    <td style="width: 20%">
                                      <input
                                        class="form-control"
                                        type="number"
                                        formControlName="port"
                                        required
                                        (change)="
                                          changeValue(
                                            this.getUpstream.at(i).get('port')
                                              .value,
                                            'port',
                                            i
                                          )
                                        "
                                      />
                                      <span
                                        class="form-text text-danger"
                                        *ngIf="u.value.checkPortServie"
                                      >
                                        {{
                                          u.value.checkPortServie | translate
                                        }}
                                      </span>
                                    </td>
                                    <td style="width: 30%">
                                      <select
                                        class="form-control"
                                        formControlName="type"
                                        required
                                      >
                                        <option
                                          [ngValue]="mainStreamType.value"
                                          *ngFor="
                                            let mainStreamType of mainStreamTypes
                                          "
                                        >
                                          {{ mainStreamType.name }}
                                        </option>
                                      </select>
                                    </td>
                                    <td style="width: 30%">
                                      <select
                                        class="form-control"
                                        formControlName="protocol"
                                        required
                                        (mouseenter)="openService(u, i)"
                                      >
                                        <option
                                          [ngValue]="itemProtocol.value"
                                          *ngFor="
                                            let itemProtocol of listProtocol
                                          "
                                        >
                                          {{ itemProtocol.name }}
                                        </option>
                                      </select>
                                      <div
                                        class="_tooltip tooltip__initiator text-center"
                                        *ngIf="u.value.hoverSSL"
                                        style="left: 47%"
                                      >
                                        <div
                                          class="tooltip__item"
                                          style="
                                            width: 400px;
                                            background: none;
                                            padding-bottom: 100px;
                                          "
                                        >
                                          <div class="card m-0">
                                            <div class="card-header">
                                              <span style="color: white"
                                                >SSL Name</span
                                              >
                                              <button
                                                type="button"
                                                class="close"
                                                aria-label="Close"
                                                (click)="
                                                  u.value.hoverSSL =
                                                    !u.value.hoverSSL
                                                "
                                              >
                                                <i
                                                  class="fa fa-times"
                                                  style="color: yellow"
                                                ></i>
                                              </button>
                                            </div>

                                            <div class="card-body">
                                              <div
                                                class="row justify-content-center"
                                              >
                                                <div class="col">
                                                  <select
                                                    class="form-control"
                                                    formControlName="ssl_id"
                                                    required
                                                  >
                                                    <option
                                                      [ngValue]="ssl.id"
                                                      *ngFor="let ssl of ssLs"
                                                    >
                                                      {{ ssl.ssl_name }}
                                                    </option>
                                                  </select>
                                                </div>
                                              </div>
                                            </div>
                                          </div>
                                        </div>
                                      </div>
                                    </td>
                                    <td size="10%">
                                      <button
                                        class="btn btn-danger btn-sm"
                                        (click)="removeUpstream(i)"
                                      >
                                        <i class="fa fa-minus"></i>
                                      </button>
                                    </td>
                                  </tr>
                                </tbody>
                              </table>
                            </div>
                          </form>
                          <div
                            class="justify-content-center"
                            style="display: grid"
                          >
                            <button
                              (click)="addPort()"
                              [disabled]="
                                !this.websiteForm.get('upstream').valid
                              "
                              class="btn btn-primary btn-sm mb-5"
                            >
                              <i class="fa fa-plus"></i>
                            </button>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </td>

                <td
                  *ngIf="editing[i]"
                  [formGroup]="websiteForm"
                  class="text-center"
                >
                  <label class="switch switch-pill switch-success">
                    <input
                      type="checkbox"
                      class="switch-input"
                      checked
                      formControlName="cache"
                    />
                    <span class="switch-slider"></span>
                  </label>
                </td>
                <td *ngIf="editing[i]" [formGroup]="websiteForm">
                  <button
                    class="btn btn-block btn-outline-primary"
                    (click)="listenPortTooltip = !listenPortTooltip"
                  >
                    {{ "websites.detail" | translate }}
                  </button>
                  <span class="form-text text-danger" *ngIf="checkListened">
                    {{ checkListened | translate }}
                  </span>
                  <div
                    class="_tooltip tooltip__initiator text-left"
                    *ngIf="listenPortTooltip"
                  >
                    <div class="tooltip__item" style="width: 400px">
                      <div class="card m-0">
                        <div class="card-header">
                          <span style="color: white">
                            {{ "websites.listened_config" | translate }}
                          </span>
                          <button
                            type="button"
                            class="close"
                            aria-label="Close"
                            (click)="listenPortTooltip = !listenPortTooltip"
                          >
                            <i class="fa fa-times" style="color: yellow"></i>
                          </button>
                        </div>
                        <div class="card-body">
                          <form [formGroup]="websiteForm">
                            <div formGroupName="listened">
                              <div class="row justify-content-center">
                                <div class="col-4" style="color: white">
                                  {{ "websites.protocol" | translate }}
                                </div>
                                <div class="col">
                                  <select
                                    class="form-control"
                                    style="width: 85%; display: unset"
                                    formControlName="protocol"
                                    required
                                    (mouseenter)="
                                      openSSLListened(getListened.controls, i)
                                    "
                                  >
                                    <option
                                      [ngValue]="itemProtocol.value"
                                      *ngFor="let itemProtocol of listProtocol"
                                    >
                                      {{ itemProtocol.name }}
                                    </option>
                                  </select>
                                  <div
                                    class="_tooltip tooltip__initiator text-left"
                                    *ngIf="sslTooltipListened"
                                  >
                                    <div
                                      class="tooltip__item"
                                      style="width: 300px"
                                    >
                                      <div class="card m-0">
                                        <div class="card-header">
                                          <span style="color: white"
                                            >SSL Name</span
                                          >
                                          <button
                                            type="button"
                                            class="close"
                                            aria-label="Close"
                                            (click)="
                                              sslTooltipListened =
                                                !sslTooltipListened
                                            "
                                          >
                                            <i
                                              class="fa fa-times"
                                              style="color: yellow"
                                            ></i>
                                          </button>
                                        </div>
                                        <div class="card-body">
                                          <form [formGroup]="websiteForm">
                                            <div formArrayName="listened">
                                              <select
                                                class="form-control"
                                                formControlName="ssl_id"
                                                required
                                              >
                                                <option
                                                  [ngValue]="ssl.id"
                                                  *ngFor="let ssl of ssLs"
                                                >
                                                  {{ ssl.ssl_name }}
                                                </option>
                                              </select>
                                            </div>
                                          </form>
                                        </div>
                                      </div>
                                    </div>
                                  </div>
                                </div>
                              </div>
                              <div
                                class="row justify-content-center"
                                style="margin-top: 5%"
                              >
                                <div class="col-4" style="color: white">
                                  {{ "websites.main_port" | translate }}
                                </div>
                                <div class="col">
                                  <input
                                    style="width: 85%; display: unset"
                                    class="form-control"
                                    type="text"
                                    formControlName="main"
                                    required
                                  />
                                </div>
                              </div>
                              <div
                                class="row justify-content-center"
                                formArrayName="redirect"
                                style="margin-top: 5%"
                              >
                                <div
                                  class="col-4"
                                  style="margin-top: 2%; color: white"
                                >
                                  {{ "websites.redirect_port" | translate }}
                                </div>
                                <div class="col">
                                  <div
                                    class="row-12"
                                    *ngFor="
                                      let u of getRedirectPort.controls;
                                      let i = index
                                    "
                                    style="margin-top: 2%"
                                  >
                                    <input
                                      class="form-control"
                                      type="text"
                                      [formControlName]="i"
                                      style="width: 85%; display: unset"
                                    />
                                    <button
                                      class="btn btn-danger btn-sm"
                                      (click)="removeRedirectPort(i)"
                                    >
                                      <i class="fa fa-minus"></i>
                                    </button>
                                  </div>
                                </div>
                              </div>
                            </div>
                          </form>
                          <div
                            class="justify-content-center"
                            style="display: grid; margin-top: 2%"
                          >
                            <button
                              (click)="addRedirectPort()"
                              [disabled]="
                                !this.websiteForm.get('listened').valid
                              "
                              class="btn btn-primary btn-sm mb-5"
                            >
                              <i class="fa fa-plus"></i>
                            </button>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </td>
                <td
                  class="text-center"
                  *ngIf="editing[i]"
                  [formGroup]="websiteForm"
                >
                  <div class="btn-group">
                    <button
                      type="button"
                      class="btn btn-primary btn-sm"
                      [disabled]="add"
                      (click)="editSave(i)"
                    >
                      <i class="fa fa-save"></i>
                      <span class="d-none d-md-inline">{{
                        "common.save" | translate
                      }}</span>
                    </button>
                    <button
                      type="button"
                      (click)="editCancel(i)"
                      class="btn btn-danger btn-sm"
                      [disabled]="add"
                    >
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{
                        "common.cancel" | translate
                      }}</span>
                    </button>
                  </div>
                </td>
              </tr>

              <!--            add new-->
              <tr *ngIf="add" [formGroup]="websiteForm">
                <td>
                  <input
                    class="form-control"
                    [placeholder]="'website' | translate"
                    type="text"
                    formControlName="website_domain"
                    (change)="
                      changeValue(
                        this.websiteForm.get('website_domain').value,
                        'domain'
                      )
                    "
                  />
                  <span class="form-text text-danger" *ngIf="checkDomain">
                    {{ checkDomain | translate }}
                  </span>
                </td>

                <td>
                  <button
                    class="btn btn-block btn-outline-primary"
                    (click)="ipPortTooltip = !ipPortTooltip"
                  >
                    {{ "websites.detail" | translate }}
                  </button>
                  <span class="form-text text-danger" *ngIf="checkService">
                    {{ checkService | translate }}
                  </span>

                  <div
                    class="_tooltip tooltip__initiator text-left"
                    *ngIf="ipPortTooltip"
                  >
                    <div class="tooltip__item" style="width: 628px">
                      <div class="card m-0">
                        <div class="card-header">
                          <span style="color: white">
                            {{ "websites.service_config" | translate }}
                          </span>
                          <button
                            type="button"
                            class="close"
                            aria-label="Close"
                            (click)="ipPortTooltip = !ipPortTooltip"
                          >
                            <i class="fa fa-times" style="color: yellow"></i>
                          </button>
                        </div>
                        <div class="card-body">
                          <form [formGroup]="websiteForm">
                            <div formArrayName="upstream">
                              <table class="table table-borderless">
                                <thead>
                                  <tr>
                                    <th class="text-center">
                                      {{ "websites.ip" | translate }}
                                    </th>
                                    <th class="text-center">
                                      {{ "websites.port" | translate }}
                                    </th>
                                    <th class="text-center">
                                      {{ "websites.type" | translate }}
                                    </th>
                                    <th class="text-center">
                                      {{ "websites.protocol" | translate }}
                                    </th>
                                  </tr>
                                </thead>
                                <tbody>
                                  <tr
                                    *ngFor="
                                      let u of getUpstream.controls;
                                      let i = index
                                    "
                                    [formGroupName]="i"
                                  >
                                    <td style="width: 30%">
                                      <input
                                        class="form-control"
                                        type="text"
                                        formControlName="ip"
                                        required
                                        pattern="^((^\s*((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))\s*$)|(^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$))$"
                                        (change)="
                                          changeValue(
                                            this.getUpstream.at(i).get('ip')
                                              .value,
                                            'ip',
                                            i
                                          )
                                        "
                                      />
                                      <span
                                        class="form-text text-danger"
                                        *ngIf="u.value.checkIpServie"
                                      >
                                        {{ u.value.checkIpServie | translate }}
                                      </span>
                                    </td>
                                    <td style="width: 20%">
                                      <input
                                        class="form-control"
                                        type="number"
                                        formControlName="port"
                                        required
                                        (change)="
                                          changeValue(
                                            this.getUpstream.at(i).get('port')
                                              .value,
                                            'port',
                                            i
                                          )
                                        "
                                      />
                                      <span
                                        class="form-text text-danger"
                                        *ngIf="u.value.checkPortServie"
                                      >
                                        {{
                                          u.value.checkPortServie | translate
                                        }}
                                      </span>
                                    </td>
                                    <td class="pl-0 pr-0" style="width: 20%">
                                      <select
                                        *ngIf="i === 0"
                                        class="form-control"
                                        formControlName="type"
                                        required
                                      >
                                        <option
                                          [ngValue]="mainStreamTypes[0].value"
                                          [defaultSelected]="
                                            mainStreamTypes[0].value
                                          "
                                        >
                                          {{ mainStreamTypes[0].name }}
                                        </option>
                                      </select>
                                      <select
                                        *ngIf="i !== 0"
                                        class="form-control"
                                        formControlName="type"
                                        required
                                      >
                                        <option
                                          [ngValue]="mainStreamType.value"
                                          *ngFor="
                                            let mainStreamType of mainStreamTypes
                                          "
                                        >
                                          {{ mainStreamType.name }}
                                        </option>
                                      </select>
                                    </td>
                                    <td style="width: 20%">
                                      <select
                                        class="form-control"
                                        formControlName="protocol"
                                        required
                                        (mouseenter)="openService(u, i)"
                                      >
                                        <option
                                          [ngValue]="itemProtocol.value"
                                          *ngFor="
                                            let itemProtocol of listProtocol
                                          "
                                        >
                                          {{ itemProtocol.name }}
                                        </option>
                                      </select>
                                      <div
                                        class="_tooltip tooltip__initiator text-center"
                                        *ngIf="u.value.hoverSSL"
                                        style="left: 47%"
                                      >
                                        <div
                                          class="tooltip__item"
                                          style="
                                            width: 400px;
                                            background: none;
                                            padding-bottom: 100px;
                                          "
                                        >
                                          <div class="card m-0">
                                            <div class="card-header">
                                              <span style="color: white"
                                                >SSL Name</span
                                              >
                                              <button
                                                type="button"
                                                class="close"
                                                aria-label="Close"
                                                (click)="
                                                  u.value.hoverSSL =
                                                    !u.value.hoverSSL
                                                "
                                              >
                                                <i
                                                  class="fa fa-times"
                                                  style="color: yellow"
                                                ></i>
                                              </button>
                                            </div>

                                            <div class="card-body">
                                              <div
                                                class="row justify-content-center"
                                              >
                                                <div class="col">
                                                  <select
                                                    class="form-control"
                                                    formControlName="ssl_id"
                                                    required
                                                  >
                                                    <option
                                                      [ngValue]="ssl.id"
                                                      *ngFor="let ssl of ssLs"
                                                    >
                                                      {{ ssl.ssl_name }}
                                                    </option>
                                                  </select>
                                                </div>
                                              </div>
                                            </div>
                                          </div>
                                        </div>
                                      </div>
                                    </td>
                                    <td>
                                      <button
                                        class="btn btn-danger btn-sm"
                                        (click)="removeUpstream(i)"
                                      >
                                        <i class="fa fa-minus"></i>
                                      </button>
                                    </td>
                                  </tr>
                                </tbody>
                              </table>
                            </div>
                          </form>
                          <div
                            class="justify-content-center"
                            style="display: grid"
                          >
                            <button
                              (click)="addPort()"
                              [disabled]="
                                !this.websiteForm.get('upstream').valid
                              "
                              class="btn btn-primary btn-sm mb-5"
                            >
                              <i class="fa fa-plus"></i>
                            </button>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </td>

                <td class="text-center">
                  <label class="switch switch-pill switch-success">
                    <input
                      type="checkbox"
                      class="switch-input"
                      checked
                      formControlName="cache"
                    />
                    <span class="switch-slider"></span>
                  </label>
                </td>
                <td>
                  <button
                    class="btn btn-block btn-outline-primary"
                    (click)="listenPortTooltip = !listenPortTooltip"
                  >
                    {{ "websites.detail" | translate }}
                  </button>
                  <span class="form-text text-danger" *ngIf="checkListened">
                    {{ checkListened | translate }}
                  </span>
                  <div
                    class="_tooltip tooltip__initiator text-left"
                    *ngIf="listenPortTooltip"
                  >
                    <div class="tooltip__item" style="width: 400px">
                      <div class="card m-0">
                        <div class="card-header">
                          <span style="color: white">
                            {{ "websites.listened_config" | translate }}
                          </span>
                          <button
                            type="button"
                            class="close"
                            aria-label="Close"
                            (click)="listenPortTooltip = !listenPortTooltip"
                          >
                            <i class="fa fa-times" style="color: yellow"></i>
                          </button>
                        </div>
                        <div class="card-body">
                          <form [formGroup]="websiteForm">
                            <div formGroupName="listened">
                              <div class="row justify-content-center">
                                <div class="col-4" style="color: white">
                                  {{ "websites.protocol" | translate }}
                                </div>
                                <div class="col">
                                  <select
                                    class="form-control"
                                    style="width: 85%; display: unset"
                                    formControlName="protocol"
                                    required
                                    (mouseenter)="
                                      openSSLListened(getListened.controls, i)
                                    "
                                  >
                                    <option
                                      [ngValue]="itemProtocol.value"
                                      *ngFor="let itemProtocol of listProtocol"
                                    >
                                      {{ itemProtocol.name }}
                                    </option>
                                  </select>
                                  <div
                                    class="_tooltip tooltip__initiator text-left"
                                    *ngIf="sslTooltipListened"
                                  >
                                    <div
                                      class="tooltip__item"
                                      style="width: 300px"
                                    >
                                      <div class="card m-0">
                                        <div class="card-header">
                                          <span style="color: white"
                                            >SSL Name</span
                                          >
                                          <button
                                            type="button"
                                            class="close"
                                            aria-label="Close"
                                            (click)="
                                              sslTooltipListened =
                                                !sslTooltipListened
                                            "
                                          >
                                            <i
                                              class="fa fa-times"
                                              style="color: yellow"
                                            ></i>
                                          </button>
                                        </div>
                                        <div class="card-body">
                                          <form [formGroup]="websiteForm">
                                            <div formArrayName="listened">
                                              <select
                                                class="form-control"
                                                formControlName="ssl_id"
                                                required
                                              >
                                                <option
                                                  [ngValue]="ssl.id"
                                                  *ngFor="let ssl of ssLs"
                                                >
                                                  {{ ssl.ssl_name }}
                                                </option>
                                              </select>
                                            </div>
                                          </form>
                                        </div>
                                      </div>
                                    </div>
                                  </div>
                                </div>
                              </div>
                              <div
                                class="row justify-content-center"
                                style="margin-top: 5%"
                              >
                                <div class="col-4" style="color: white">
                                  {{ "websites.main_port" | translate }}
                                </div>
                                <div class="col">
                                  <input
                                    style="width: 85%; display: unset"
                                    class="form-control"
                                    type="text"
                                    formControlName="main"
                                    required
                                  />
                                </div>
                              </div>
                              <div
                                class="row justify-content-center"
                                formArrayName="redirect"
                                style="margin-top: 5%"
                              >
                                <div
                                  class="col-4"
                                  style="margin-top: 2%; color: white"
                                >
                                  {{ "websites.redirect_port" | translate }}
                                </div>
                                <div class="col">
                                  <div
                                    class="row-12"
                                    *ngFor="
                                      let u of getRedirectPort.controls;
                                      let i = index
                                    "
                                    style="margin-top: 2%"
                                  >
                                    <input
                                      class="form-control"
                                      type="text"
                                      [formControlName]="i"
                                      style="width: 85%; display: unset"
                                    />
                                    <button
                                      class="btn btn-danger btn-sm"
                                      (click)="removeRedirectPort(i)"
                                    >
                                      <i class="fa fa-minus"></i>
                                    </button>
                                  </div>
                                </div>
                              </div>
                            </div>
                          </form>
                          <div
                            class="justify-content-center"
                            style="display: grid; margin-top: 2%"
                          >
                            <button
                              (click)="addRedirectPort()"
                              class="btn btn-primary btn-sm mb-5"
                            >
                              <i class="fa fa-plus"></i>
                            </button>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </td>

                <td class="text-center">
                  <div class="btn-group">
                    <button (click)="save()" class="btn btn-primary btn-sm">
                      <i class="fa fa-save"></i>
                      <span class="d-none d-md-inline">{{
                        "common.save" | translate
                      }}</span>
                    </button>
                    <button
                      type="button"
                      (click)="cancelSave()"
                      class="btn btn-danger btn-sm"
                    >
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{
                        "common.cancel" | translate
                      }}</span>
                    </button>
                  </div>
                </td>
              </tr>
            </tbody>
          </table>
          <div class="row justify-content-between" *ngIf="websites.length > 0">
            <span class="col-6">{{
              "common.pagingInfo"
                | translate
                  : {
                      start: paging.offset + 1,
                      end: paging.offset + websites.length,
                      total: paging.total
                    }
            }}</span>

            <div class="col-6">
              <ngb-pagination
                class="float-right"
                [boundaryLinks]="true"
                [collectionSize]="paging.total"
                [pageSize]="paging.limit"
                [maxSize]="5"
                [rotate]="true"
                [(page)]="paging.page"
                (pageChange)="loadPage(paging.page)"
                [disabled]="add || editStatus"
              >
              </ngb-pagination>
            </div>
          </div>
          <div *ngIf="websites.length === 0" class="text-center">
            <span>{{ "common.no_record" | translate }}</span>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">
      {{ "object.website.delete_popup.title" | translate }}
    </h4>
    <button
      type="button"
      class="close"
      aria-label="Close"
      (click)="modal.dismiss('Cross click')"
    >
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{
      "object.website.delete_popup.message"
        | translate: { name: selectedWebsite.website_domain }
    }}
  </div>
  <div class="modal-footer">
    <button
      type="button"
      class="btn btn-danger"
      (click)="modal.close('delete')"
    >
      {{ "common.delete" | translate }}
    </button>
    <button
      type="button"
      class="btn btn-secondary"
      (click)="modal.close('Close')"
    >
      {{ "common.close" | translate }}
    </button>
  </div>
</ng-template>
